'use strict';

const {isNewlineBetweenSiblings} = require('../../is');
const {printParams} = require('./params');
const {printKey} = require('./kind');

module.exports.ObjectMethod = {
    beforeIf(path) {
        return path.node.async;
    },
    before(path, {write}) {
        write('async ');
    },
    print(path, printer, semantics) {
        const {print} = printer;
        
        printKey(path, printer);
        printParams(path, printer, semantics);
        
        print.space();
        print('__body');
    },
    afterIf(path) {
        return isNewlineBetweenSiblings(path);
    },
    after(path, {print}) {
        print.linebreak();
    },
};
